% ========================================
% CLASSICAL LEAST SQUARES
% ========================================
% Using ARX, if you have it, will give 
% the same result.
disp('Delay operator identification')

% compute excitation matrices
Qtemp = excitation(y,u,1,2);
Q = Qtemp(2:5,2:5);
R = Qtemp(2:5,1);

% solve least squares
theta=Q\R;

% convert to continuous time
dId = [1,-theta(1:2)'];
nId = [0,theta(3:4)'];
nId = nId*(ny/nu);
[z,p,k]=tf2zp(nId,dId);
[ZId,PId,KId]=zpd2zpc(z,p,k,1);
PId=sort(PId);

% ----------------------------------------
% get performances
% Evaluate nominal and identified time constants
[Zp,Pp,Kp] = zp2tc(Z,P,K);
[ZIdp,PIdp,KIdp]=zp2tc(ZId,PId,KId);
err=([ZIdp;PIdp;KIdp]-[Zp;Pp;Kp])./[Zp;Pp;Kp];
disp('    ref.      ident.    rel. err.')
disp([[Zp;Pp;Kp],[ZIdp;PIdp;KIdp],err])

