function Q = excDelta(y,u,nn,nd,step)
% CovMatrix = excDelta(out,in,numDeg,denDeg,step)
% Global excitation for LS identification
% with Delta operator. 
% We have Delta y(k) = (y(k+1) - y(k))/step.
% At that time, SISO systems only.

if size(y) ~= size(u);
	break;
end;

l = length(y);
zz = zeros(l-nd,nn+nd+2);
for i=1:nd+1;
	zz(:,i) = y(nd-i+2:l-i+1);
end;
for i=2:nn+2;
	zz(:,nd+i) = u(nn-i+3:l+nn-nd-i+2);
end;

% applying exact polynomials is more 
% robust than repeated finite differences
z = zeros(l-nd,nn+nd+2);
P = 1;
for i=nd+1:-1:1;
	z(:,i) = zz(:,i:nd+1)*P';
	P=conv(P,[1 -1])/step;
end;
P = 1;
for i=nn+1:-1:1;
	z(:,i+nd+1) = zz(:,i+nd+1:nn+nd+2)*P';
	P=conv(P,[1 -1])/step;
end;


m = mean(z);
c = cov(z);
Q = c+m'*m;
