% ========================================
% PLANT SIMULATION
% ========================================
% Input your system data here.
% Z is the zero, P the poles'matrix,
% and GS is the static gain.
% hor is the horizon
Z = -1/500;
P = [ -1/1000 ; -1/10 ];
GS = 2;
P = sort(P);
hor = 3000;
% get the high frequency gain
K = (GS*prod(-P))/prod(-Z);

% simulate response with discretized system
disp('Computing response')
uref = rand(hor,1);
% uncomment next line if you wish; the 
% identification results seem to be 
% better when one keeps the signal's 
% average.
%uref = uref-mean(uref);
yref = dofilter(Z,P,K,uref,1);

% Data truncation; put in "digits" the number of
% significant digits you wish to retain.
digits = 3
[y,ny] = fixdig(yref,digits);
[u,nu] = fixdig(uref,digits);
% Signal normalization
y=y/ny;
u=u/nu;
